#!/usr/local/bin/python
""" 
    showdb - A utility to show the tables/structures owned by a user
	     (only tested with ADABAS D)

    Author: Marc-Andre Lemburg, 1997

    Based on an initial idea by Justin Sher.

    This script needs Python 1.5 (http://www.python.org) and the
    ODBC interface package mxODBC which can be downloaded from
    http://starship.skyport.net/~lemburg/mxODBC.html.
"""

import sys,string

# Get parameters
if len(sys.argv) == 4:
    user, passwd, dbname = sys.argv[1:]
    owner = user
elif len(sys.argv) == 5:
    user, passwd, dbname, owner = sys.argv[1:]
else:
    print 'syntax:  showdb <username> <password> <database> [<owner>]'
    print '         (owner defaults to username)'
    print 'example: showdb test test localhost:MYDB'
    sys.exit(1)

# Connect
try:
    from ODBC.Adabas import Connect,OperationalError
    db = Connect(dbname,user,passwd)
except ImportError:
    print 'ODBC package could not be imported.'
    sys.exit(1)
except OperationalError:
    print 'Could not connect.'
    sys.exit(1)

# Create cursor
c = db.cursor()

try:
    # Execute a SQL command
    c.execute("select tablename, columnname, datatype, len "
	      "from domain.columns where owner='%s' order by tablename"
	      % string.upper(owner))

    # Retrieve the data
    result = c.fetchall()

    # Output report
    if result:
	print '%-20s: %-20s (%s)\t%s' % \
	      ('TABLENAME','COLUMNNAME','TYPE','LENGTH')
	print '-'*72
	for table,column,type,len in result:
	    print '%-20s: %-20s (%s)\t%s' \
		  % (table,column,type,str(len))
    else:
	print 'No data available.'

except OperationalError:
    print 'Error reading data.'
    sys.exit(1)
