""" dbi abstraction module for mxODBC

    Note: This module has not undergone enough debugging yet. If you
    find any bugs or inconsistencies, please let me know. Thank you.

    This module is obsolete as of DB API 2.0 and will no longer be
    maintained.

"""
__version__ = '1.1.1'

import types

# Load the DB API interface for this specific database
import __init__
DB_API = __init__

# Version check (XXX disabled)
if 0 and DB_API.__version__ != __version__:
    raise DB_API.error,"dbi and DB_API versions don't match"

# Get DateTime construtors
from DateTime import DateTimeType, DateTimeFromTicks, Date, Timestamp, \
                     DateTimeDeltaType, DateTimeDeltaFromSeconds, Time

# Alias to the DB_API SQL class
SQL = DB_API.SQL

# Do some name aliasing (to be PythonWin odbc compatible)
error = DB_API.Error
dataError = DB_API.DataError
integrityError = DB_API.IntegrityError
internalError = DB_API.InternalError
noError = DB_API.Warning
opError = DB_API.OperationalError
progError = DB_API.ProgrammingError

### Constructors

def dbiDate(value):

    """ Convert a date value to the database interface date type
    """
    if type(value) == DateTimeType:
	return value
    if type(value) == types.FloatType or \
       type(value) == types.IntType:
	return DateTimeFromTicks(value)
    if type(value) == types.TupleType:
	return Date(value[0],value[1],value[2])
    if value is None:
	return None
    raise TypeError,'unsupported value type'

dbiTimestamp = dbiDate

def dbiTime(value):

    """ Convert a time value to the database interface time type
    """
    if type(value) == DateTimeDeltaType:
	return value
    if type(value) == types.FloatType or \
       type(value) == types.IntType:
	return DateTimeDeltaFromSeconds(value)
    if type(value) == types.TupleType:
	return Time(value[0],value[1],value[2])
    if value is None:
	return None
    raise TypeError,'unsupported value type'

def dbiRaw(value):

    """ Convert the string value to the database raw (long binary) type
    """
    if value is None:
	return None
    return str(value)

Binary = dbiRaw

### Type objects

# Helper
class _HybridValue:
    def __init__(self,*values):
	self.values = values
    def __cmp__(self,other):
	if other in self.values:
	    return 0
	if other < self.values:
	    return 1
	else:
	    return -1

# Note that tests like 'coltype is STRING' don't work, you have
# use 'coltype == STRING'.
STRING = _HybridValue(SQL.CHAR,
		      SQL.BINARY)
BINARY = _HybridValue(SQL.LONGVARCHAR,
		      SQL.LONGVARBINARY)
RAW = BINARY
NUMBER = _HybridValue(SQL.DECIMAL,
		      SQL.NUMERIC,
		      SQL.DOUBLE,
		      SQL.FLOAT,
		      SQL.REAL,
		      SQL.DOUBLE,
		      SQL.INTEGER,
		      SQL.TINYINT,
		      SQL.SMALLINT,
		      SQL.BIT,
		      SQL.BIGINT)
DATE = _HybridValue(SQL.DATE)
TIME = _HybridValue(SQL.TIME)
TIMESTAMP = _HybridValue(SQL.TIMESTAMP)

# mxODBC doesn't support RowID columns; use cursor.specialcolumns() to
# find out which columns are best suited to uniquely identify a row.
# This object is not equal to any other object.
ROWID = _HybridValue()
